/* FOR AUDIO */
var audioStream;
var audioZapper;
var audioSleep;
var audioAlarm;
var audioAdReplacement;
var isPlaying = false;
var isPlayingAra = false;
var intentionalStop = false;
var readyStateInterval = null;
var timeoutID;

/* STATION CONTROL */
var theCallSign;
var theAuthToken;
var playSessionID;
var theStreamUrl;
var liveStreamUrl;
var statusUrl;
var showAds;
var dcsTriggerDelay;

/* IMAGE URLS */
var bgUrl = null;
var logoUrl;
var defAlbumArt;

/* STATION INFORMATION */
var facebookUrl;
var twitterUrl;
var youtubeUrl;
var stationUrl;
var stationSlogan;
var stationInfo;
var stationPhone;
var stationEmail;

/* ONDEMAND SPECIFIC */
var odPlayer = false;
var ondemand;
var myStreamRoot;
var myOdPath;
var fileList = [];
var impressionMarkUrl;
var impressionMarkList = [];
var impressionMarks;
var theOdImpressionMarkTime;
var myOdImage;
var myOdCampaignId;
var flagClear;
var streamStartMode;
var odAutoStart;

/* MULTISTATION SPECIFIC */
var stationGroup;
var stationList = [];

/* SONG INFORMATION */
var theTitle;
var theArtist;
var theAlbum;
var curTitle;
var songPos;
var songStart;
var songDuration = 0;
var programStartTS;

/* MISC VARIABLES */
var jPM;
var songProgressRefresh;
var localServerTSUTC;
var localServerTSoffset;
var pE = {
	position: "",
	duration: "",
	offset: ""
};
var myWidth		=	($(window).width() * 0.70);
var myPlWidth	=	($(window).width() * 0.50);
var mzWidth		=	($(window).width() * 0.50);
var sleepMin;
var sleepTimer;
var sleepSound;
var zapperRunning = false;
var sleepSoundList = ["Radio","Rain","Rainforest","Surf","Whitenoise"];
var sleepTimeList = ["05","10","15","20","25","30","35","40","45","50","55","60"];
var sleepSelectBoxString = "";
var alarmTime;
var theAlarm;
var alarmPlaying = false;
var alarmScheduled = false;
var shareList = ["Facebook","Twitter","Google","Email"];
var blackoutActive = "false";
var alreadyDisplayedBlackoutMessage = false;
var scrollerPosition;

/* AD STUFF */
var advertising;
var playerAdvertisingMode;
var prerollBannerDuration;
var bannerRotationFqcy;
var rejoinPriority;
var sLocaFillOnAdnFail;
var sTerrFillOnLocalFail;
var sBedFillOnAllFail;
var sBedFillFileName;
var sTspStnId;
var sGenre;
var adCampaignGetURL;
var deviceType;
var deviceOrientation = "p";
var geoCTCode;
var geoDMACode;
var prerollCompleted;
var responseString;
var bannerImageUrl;
var bannerLinkUrl;
var thisDevice = "";
var prbCompleted = false;
var praCompleted = false;
var prerollPlaying = false;
var oldTimeStamp = -1;
var curTimeStamp;

/* SOME STRINGS */
var stringAlarmSetMessage		=	"Alarm is set for";
var stringAlarmCancelled		=	"Alarm Cancelled";
var stringTimerStopped			=	"Sleep Timer Stopped";
var stringTimerRunning			=	"Sleep Timer Running";
var stringAdMode				=	"Please wait";
var stringAdMode2				=	"Live stream returning";
var stringLiveStream			=	"Live stream";
var stringSongTimerPlaceholder	=	"--:--";
var stringNoLyrics				=	"No Lyrics Found!";
var stringShareSendParams		=	"&title=I%27m+listening+to+";
var stringBlackoutNotification	=	"This station is currently in blackout mode. The audio stream will resume when the backout has ended.";

/* SOME URLS */
var urlShare					=	"http://api.addthis.com/oexchange/0.8/forward/";
var urlShareSend				=	"/offer?url=http://rdo.to/";
var urlStationInfo				=	"http://radio.securenetsystems.net/dx/config_app.cfm?stationCallSign=";
var urlLyricsProvider			=	"https://radio.securenetsystems.net/dx/get_lyrics.cfm?cReturnType=xml&stationCallSign=";
var urlPlaylistProvider			=	"http://radio.securenetsystems.net/dx/get_playlist_history.cfm?authToken=";
var urlBuyMedia					=	"http://radio.securenetsystems.net/get_tune_buy_link.cfm?stationcallsign=";
var urlCheckBlackout			=	"http://radio.securenetsystems.net/dx/blackout_check.cfm?stationCallSign=";

// INITIAL SETUP STUFF
$(document).ready(function() {
	$.support.cors = true;
	audioStream = new Audio();

	// FOR PREROLL BANNER POPUP
	$("#bgPopup").data("state",0);
	$("#popupClose").click(function(e) {
		e.preventDefault();
		e.stopPropagation();
		disablePopup();
		return false;
	});
	// END

	// DEVICE TYPE
	deviceType = navigator.platform;
	if (deviceType === "iPhone") {
		thisDevice = "p";
		scrollerPosition = "top";
	} else {
		thisDevice = "t";
		// scrollerPosition = "bubble";
		scrollerPosition = "modal";
	}
	// END

	// DYNAMICALLY POPULATES SLEEPTIMER SCROLLER
	for (var i = 0; i < sleepSoundList.length; i++) {
		sleepSelectBoxString += "<li>" + sleepSoundList[i] + "<ol>";
		for (var ii = 0; ii < sleepTimeList.length; ii++) {
			sleepSelectBoxString += "<li>" + sleepTimeList[ii] + "</li>";
		}
		sleepSelectBoxString += "</ol></li>";
	}
	$('#sleepCombo').append(sleepSelectBoxString);
	// END

	// INITIALIZES TIMESCROLLERS FOR ALARM AND SLEEP TIMER
	var now = new Date();
	$('#alarmTime').mobiscroll().datetime({
		minDate: new Date(now.getFullYear(), now.getMonth(), now.getDate()),
		theme: 'ios',
		display: scrollerPosition,
		inputClass: 'i-txt',
		mode: 'scroller',
		anchor: $('#alarmTime')
	});
	$('#alarmShow').click(function() {
		$('#alarmTime').mobiscroll('show');
		return false;
	});
	$('#alarmClear').click(function() {
		$('#alarmTime').val('');
		theAlarm = null;
		alarmPlaying = false;
		alarmScheduled = false;
		navigator.notification.alert(stringAlarmCancelled);
		return false;
	});
	$('#sleepCombo').mobiscroll().treelist( {
		theme: 'ios',
		display: scrollerPosition,
		mode: 'scroller',
		inputClass: 'i-txt'
	});
	$('#sleepShow').click(function() {
		$('#sleepCombo').mobiscroll('show');
		return false;
	});
	$('#sleepCancel').click(function() {
		audioSleep.pause();
		clearInterval(sleepTimer);
		sleepTimer = false;
		$('#sleepStatus').text(stringTimerStopped);
		realignSongInfo();
		$('#playerTransport').show();
		return false;
	});
	$('#sleepCombo').mobiscroll('setValue', ['Rain', '05'], false, 0.5);
	// END

	// MAKE SURE WE HAVE CALLSIGN & AUTHTOKEN FIRST
	$.get('station.txt', function(data) {
		var substr = data.split(',');
		theCallSign = substr[0];
		theAuthToken = substr[1];

		fetchStationInfo();		// GETS MAIN CONTROL VALUES FOR STATION
		fetchBlackoutStatus();	// GETS BLACKOUT STATUS
		fetchSongInfo();		// GETS SONG INFO
		fetchPlaylist();		// GETS INITIAL PLAYLIST DATA
		var songInfoRefresh = setInterval(fetchSongInfo, 5000); // UPDATES SONG INFO EVERY 5 SECONDS
		var blackoutRefresh = setInterval(fetchBlackoutStatus, 5000); // UPDATES BLACKOUT STATUS EVERY 5 SECONDS
		// VARIOUS FORMATTING THINGS
		$('#makeMeScrollable').css({width: screen.width});
		$('#contactContainer').css({width: screen.width});
		$('#mosquitoZapper').attr('width', mzWidth);
		$('#mosquitoZapper').attr('height', mzWidth);
		$('#mPlayerLoadingDiv').show();

		$('.i-txt').css({'position':'relative', 'top':'50%', 'left':'50%', 'z-index':'-999999'});
		// END
	});
	// END

	formatPages();
});
// END

// RESTART STREAM ON RESUME
document.addEventListener("resume", onResume, false);
function onResume() {
	$('body').removeClass("loading");
	if (theStreamUrl.length) {
		if (prerollCompleted) {
			playThisStream();
		}
	}
}
// END

// FUNCTIONS FOR PREROLL BANNER POPUP OPERATION
function loadPopup() {
	if ($("#bgPopup").data("state") == 0) {
		$("#bgPopup").css({
			"opacity": "0.7"
		});
		$("#bgPopup").fadeIn("medium");
		$("#prerollBanner").fadeIn("medium");
		$("#bgPopup").data("state", 1);
	}
}

function disablePopup() {
	if ($("#bgPopup").data("state") == 1) {
		$("#bgPopup").fadeOut("medium");
		$("#prerollBanner").fadeOut("medium");
		$("#bgPopup").data("state", 0);

		prerollPlaying = false;
		prbCompleted = true;
	}
}

function centerPopup() {
	var winw = $(window).width();
	var winh = $(window).height();
	var popw = $('#prerollBanner').width();
	var poph = $('#prerollBanner').height();
	$("#prerollBanner").css({
		"position" : "absolute",
		"top" : winh / 2 - poph / 2,
		"left" : winw / 2 - popw / 2
	});
}
// END

// HANDLES MOSQUITO ZAPPER
function toggleZapper() {
	if (!zapperRunning) {
		var angle = 0;
		// audioZapper = new Audio('audio/frequency_sweep.mp3');  /*FREQ SWEEP USED FOR TESTING ONLY*/
		audioZapper = new Audio('audio/mosquito.mp3');
		audioZapper.addEventListener('ended', function() {
			this.currentTime = 0;
			this.play();
		}, false);
		audioZapper.play();
		zapperRunning = setInterval(function() {
			angle += 3;
			if (angle > 359) {
				angle = 0;
			}
			$('#mosquitoZapper').rotate(angle);
		}, 30);
		$('#mosquitoZapperToggle').text(' Stop ');
	} else {
		if (audioZapper) {
			audioZapper.pause();
		}
		$('#mosquitoZapper').rotate( {
			animateTo: 0
		});
		$('#mosquitoZapperToggle .ui-btn-text').text(' Start ');
		clearInterval(zapperRunning);
		zapperRunning = false;
	}
}
// END

// HANDLES SHARING SONG
function shareSong(shareService) {
	$('body').addClass("loading");
	shareUrl = urlShare + shareService.toLowerCase() + urlShareSend + theCallSign + stringShareSendParams + encodeURI(theArtist) + "+-+" + encodeURI(theTitle);
	window.open(shareUrl, '_system');
}
// END

// HANDLES ALARM
function setAlarm(params) {
	var theMonth	=	parseInt(params[0]);
	var theDay		=	parseInt(params[1]);
	var theYear		=	parseInt(params[2]);
	var theHour		=	parseInt(params[3]);
	var theMin		=	parseInt(params[4]);
	var ampm		=	parseInt(params[5]);

	var ampmString = "AM";
	var hourString;
	var minString;
	if (ampm === 1) {
		theHour += 12;
		ampmString = "PM";
	}

	if (params[3] === 0) {
		hourString = 12;
	} else {
		hourString = params[3];
	}

	if (theMin.length < 2) {
		minString = "0" + theMin;
	} else {
		minString = theMin;
	}

	alarmTime = new Date(theYear, theMonth, theDay, theHour, theMin);
	theAlarm = new Alarm({date:alarmTime.getTime(), alarmCallback:theAlarmCallback, message:stationSlogan + " - Alarm"});
	navigator.notification.alert(stringAlarmSetMessage + " " + alarmTime.format("mmm d, yyyy h:MM TT"));
	alarmScheduled = true;
	stopStream(true);

	realignSongInfo();
}
// END

// ALARM CLOCK CALLBACK
function theAlarmCallback(timeStr, message) {
	if (!alarmPlaying) {
		alarmPlaying = true;
		navigator.notification.alert(message, alertDismissed, "Alarm", "Dismiss");

		audioAlarm = new Audio("audio/beep.mp3");
		audioAlarm.addEventListener('ended', function() {
			this.currentTime = 0;
			this.play();
		}, false);
		audioAlarm.play();
	}
}
// END

// ALERT CALLBACK (FOR ALARM)
function alertDismissed() {
	alarmPlaying = false;
	alarmScheduled = false;
	audioAlarm.pause();
	audioAlarm = null;
	playThisStream();
}
// END

// HANDLES SLEEP TIMER
function setSleep(params) {
	switch (params[0]) {
	case '0':
		sleepSound = 'liveStream';
		break;
	case '1':
		sleepSound = 'audio/rain.mp3';
		break;
	case '2':
		sleepSound = 'audio/rainforest.mp3';
		break;
	case '3':
		sleepSound = 'audio/surf.mp3';
		break;
	case '4':
		sleepSound = 'audio/whitenoise.mp3';
		break;
	default:
		sleepSound = 'audio/rain.mp3';
	}
	sleepMin = ((parseInt(params[1], 10) + 1) * 5);
	sleepTimer = false;
	startTimer();
	realignSongInfo();
}

function scroll() {
	if (sleepMin > 0) {
		sleepMin--;
		$('#sleepCombo').mobiscroll('setValue', [sleepMin], false, 0.5);
	} else {
		if (sleepSound !== "liveStream") {
			audioSleep.pause();
		} else {
			stopStream(true);
		}
		clearInterval(sleepTimer);
		sleepTimer = false;
		$('#sleepStatus').text(stringTimerStopped);
		$('#sleepSave').attr('onclick', "setSleep($('#sleepTime').mobiscroll('getValue'));").bind('click');
		realignSongInfo();
		$('#playerTransport').show();
	}
}

function startTimer() {
	if (sleepSound !== 'liveStream') {
		stopStream(true);
		if (audioSleep) {
			audioSleep.pause();
			audioSleep = null;
		}
		audioSleep = new Audio(sleepSound);
		audioSleep.addEventListener('ended', function() {
			this.currentTime = 0;
			this.play();
		}, false);

		audioSleep.play();
	}
	$('#sleepStatus').text(stringTimerRunning);
	$('#playerTransport').hide();
	scroll();
	sleepTimer = setInterval(function() {
		scroll();
	}, 60000);
}
// END

// GETS MAIN CONTROL VALUES FOR STATION
function fetchStationInfo() {
	$.ajax( {
		type: 'GET',
		url: urlStationInfo + theCallSign + '&authToken=' + theAuthToken,
		dataType: 'xml',
		success: getStationInfo
	});
}

function getStationInfo(xml) {
	$(xml).find('station').each(function() {
		playSessionID			=	$(this).find('playSessionID').first().text();
		statusUrl				=	$(this).find('statusUrl').text();
		theStreamUrl			=	$(this).find('streamUrl').first().text();
		liveStreamUrl			=	theStreamUrl; // SETS A CONSTANT FOR THE LIVE STREAM URL
		audioStream.src			=	theStreamUrl; // SETS THE INITIAL SRC URL FOR THE AUDIOSTREAM
		localServerTSUTC		=	$(this).find('localServerTSUTC').first().text();
		stationSlogan			=	$(this).find('stationSlogan').first().text();
		stationInfo				=	$(this).find('stationInfo').first().text();
		bgUrl					=	$(this).find('bgUrl').first().text();
		logoUrl					=	$(this).find('logoUrl').first().text();
		defAlbumArt				=	$(this).find('dftAlbumArt').first().text();
		showAds					=	$(this).find('showAds').first().text();
		facebookUrl				=	$(this).find('socURLFacebook').first().text();
		twitterUrl				=	$(this).find('socURLTwitter').first().text();
		youtubeUrl				=	$(this).find('socURLYouTube').first().text();
		stationPhone			=	$(this).find('stationPhone').first().text();
		stationEmail			=	$(this).find('stationEmail').first().text();
		stationUrl				=	$(this).find('stationUrl').first().text();
		stationGroup			=	$(this).find('stationGroup');
		ondemand				=	$(this).find('ondemand');
		myStreamRoot			=	$(this).find('streamRoot').text();
		myOdPath				=	$(this).find('ondemand').attr('path');
		myOdImage				=	$(this).find('ondemand').attr('cover');
		streamStartMode			=	$(this).find('streamStartMode').text();
		odAutoStart				=	$(this).find('ondemand').attr('autostart');
		impressionMarkUrl		=	$(this).find('impressionMarkURL').text();
		impressionMarks			=	$(this).find('impressionMarks');
		advertising				=	$(this).find('advertising');
		geoCTCode				=	$(this).find('geoCTCode').text();
		geoDMACode				=	$(this).find('geoDMACode').text();



		// HIDES DISABLED MENU ITEMS
		if ($(this).find('stationGroup').text().length === 19) {
			$('#menuOtherStations').hide();
		}
		if ($(this).find('file').text().length === 0) {
			$('#menuOndemand').hide();
		}
		if ($(this).find('dspLyrics').text() === 'false') {
			$('#menuLyrics').hide();
		}
		if ($(this).find('statusUrl').text().length === 0) {
			$('#menuPlaylist').hide();
			$('#songInfoDiv').hide();
			$('#songTitle').text(stringLiveStream);
			$('#songArtist').text('');
			$('#songAlbum').text('');
		}
		if ($(this).find('dspBuySong').text() === 'false') {
			$('#menuBuySong').hide();
		}
		if ($(this).find('dspSocialShare').text() === 'false') {
			$('#menuShare').hide();
		}
		if ($(this).find('dspSocial').text() === 'false') {
			$('#menuFacebook').hide();
			$('#menuTwitter').hide();
			$('#menuYoutube').hide();
		} else {
			if ($(this).find('socURLFacebook').text().length === 0) {
				$('#menuFacebook').hide();
			}
			if ($(this).find('socURLTwitter').text().length === 0) {
				$('#menuTwitter').hide();
			}
			if ($(this).find('socURLYouTube').text().length === 0) {
				$('#menuYoutube').hide();
			}
		}
		if ($(this).find('dspAlarmClock').text() === 'false') {
			$('#menuAlarmClock').hide();
		}
		if ($(this).find('dspSleepTimer').text() === 'false') {
			$('#menuSleepTimer').hide();
		}
		if ($(this).find('dspMosquitoZapper').text() === 'false') {
			$('#menuMosquitoZapper').hide();
		}
		// END

		// CREATES STATION LIST IF NEEDED
		var i = 0;
		$(stationGroup).find('stGstation').each(function() {
			stationList[i] = new Array(4);
			stationList[i][0] = $(this).find('callSign').first().text();
			stationList[i][1] = $(this).find('authToken').first().text();
			stationList[i][2] = $(this).find('stationSlogan').first().text();
			stationList[i][3] = $(this).find('stationLogo').first().text();
			i++;
		});
		// END

		// CREATES FILE LIST IF NEEDED
		var ii = 0;
		$(ondemand).find('file').each(function() {
			fileList[ii] = new Array(5);
			fileList[ii][0] = $(this).find('type').first().text();
			fileList[ii][1] = $(this).find('fileName').first().text();
			fileList[ii][2] = $(this).find('fileDspName').first().text();
			fileList[ii][3] = $(this).find('duration').first().text();
			fileList[ii][4] = $(this).attr('id');
			ii++;
		});
		// END

		// CREATES IMPRESSIONMARK LIST IF NEEDED
		var iii = 0;
		$(impressionMarks).find('impressionMark').each(function() {
			impressionMarkList[iii] = new Array(3);
			impressionMarkList[iii][0] = $(this).find('type').first().text();
			impressionMarkList[iii][1] = $(this).find('markValue').first().text();
			impressionMarkList[iii][2] = $(this).find('markType').first().text();
			iii++;
		});
		// END

		// GETS ADVERTISING CONFIG
		playerAdvertisingMode	=	$(advertising).find('playerAdvertisingMode').first().text();
		prerollBannerDuration	=	$(advertising).find('prerollBannerDuration').first().text();
		bannerRotationFqcy		=	$(advertising).find('bannerRotationFqcy').first().text();
		rejoinPriority			=	$(advertising).find('rejoinPriority').first().text();
		sLocaFillOnAdnFail		=	$(advertising).find('sLocaFillOnAdnFail').first().text();
		sTerrFillOnLocalFail	=	$(advertising).find('sTerrFillOnLocalFail').first().text();
		sBedFillOnAllFail		=	$(advertising).find('sBedFillOnAllFail').first().text();
		sBedFillFileName		=	$(advertising).find('sBedFillFileName').first().text();
		sTspStnId				=	$(advertising).find('sTspStnId').first().text();
		sGenre					=	$(advertising).find('sGenre').first().text();
		adCampaignGetURL		=	$(advertising).find('adCampaignGetURL').first().text();
		// END
	});

	// SETUP MENU AND MENU SWIPING / TAPPING
	if (!jPM) {
		jPM = $.jPanelMenu({
			menu: '#panelMainMenu',
			trigger: '.menu-trigger',
			duration: 300,
			animated: true,
			closeOnContentClick: true,
			afterClose:function(){
				realignSongInfo();
			}
			// openPosition: "200px"
		});
		jPM.on();
	}

	$('.menuIcon').touchwipe({
		wipeLeft: function(){
			jPM.close();
		},
		wipeRight: function(){
			jPM.open();
		},
		preventDefaultEvents: true
	});

	$('.menuIcon').unbind('click');
	$('.menuIcon').click(function() {
		if (jPM.isOpen()) {
			jPM.close();
		} else {
			jPM.open();
		}
	});
	// END

	// HANDLE MENU LINKS
	$('.menu-trigger').click(function(e) {
		var href = this.hash.substr(1);
		page_load(href);
	});

	function page_load(href) {
		$('.pageContent').each(function() {
			$(this).hide();
		});
		$('#' + href).show();
	}
	// END

	pE.position = 0;
	pE.duration = 0;
	pE.offset = 0;
	d = new Date();
	localServerTSoffset = d.getTime() + d.getTimezoneOffset() * 60000 - Date.parse(localServerTSUTC);

	formatPages();
	if (prerollCompleted) {
		playThisStream();
	}
}
// END

// HANDLES STATION SELECTION
function loadStationList() {
	$('#stationList').empty();
	for (var i = 0; i < stationList.length; i++) {
		var myImage;
		if (stationList[i][0] === theCallSign) {
			myImage = 'images/on-air.png';
		} else {
			myImage = stationList[i][3];
		}
		$('#stationList').append('<li data-val="' + stationList[i][0] + '^' + stationList[i][1] + '"><div class="stationList"><div class="img-cont"><img src="' + myImage + '" /></div><span>' + stationList[i][2].substr(0, 15) + '</span></div></li>');
	}
	$('#stationList').mobiscroll().image( {
		theme: 'ios',
		display: scrollerPosition,
		mode: 'scroller',
		inputClass: 'i-txt',
		setText: 'Play',
		onSelect: setStation
	});
	$('#stationList').height(100);
	$('#stationList').scroller('show');
}

function setStation(stationData) {
	var substr = stationData.split('^');
		theCallSign = substr[0];
		theAuthToken = substr[1];
	stopStream(true);
	stationList.length = 0;
	$('#makeMeScrollable').smoothDivScroll('destroy');
	$('#makeMeScrollable').empty();
	fetchStationInfo();
	fetchPlaylist();
}
// END

// HANDLES FILE SELECTION
function loadFileList() {
	$('#fileList').empty();
	// ALWAYS ADD THE LIVE STREAM TO THE TOP OF THE LIST
	$('#fileList').append('<li data-val="' + liveStreamUrl + '"><div class="fileList"><div class="img-cont"><img src="' + logoUrl + '" /></div><span>' + 'Live Stream' + '</span></div></li>');
	// END
	for (var i = 0; i < fileList.length; i++) {
		var myImage;
		var thisFileUrl = myStreamRoot + "/" + myOdPath + "/" + fileList[i][1];

		if (fileList[i][2].length >= 15) {
			var thisFileTitle = fileList[i][2].substring(0,12) + "...";
		} else {
			var thisFileTitle = fileList[i][2];
		}

		if (theStreamUrl === thisFileUrl) {
			myImage = 'images/on-air.png';
		} else {
			myImage = myOdImage;
		}
		$('#fileList').append('<li data-val="' + thisFileUrl + '^' + fileList[i][2] + '^' + fileList[i][3] + fileList[i][4] + '"><div class="fileList"><div class="img-cont"><img src="' + myImage + '" /></div><span>' + thisFileTitle + '</span></div></li>');
	}
	$('#fileList').mobiscroll().image( {
		theme: 'ios',
		display: scrollerPosition,
		mode: 'scroller',
		inputClass: 'i-txt',
		setText: 'Play',
		onSelect: setFile
	});
	$('#fileList').height(100);
	$('#fileList').scroller('show');
}

function setFile(fileData) {
	var substr = fileData.split('^');
	if (substr.length === 1) {
		if (blackoutActive != "true") {
			flagClear = false;
			odPlayer = false;
			stopStream(true);
			theStreamUrl = substr[0];
			audioStream.src = theStreamUrl;

			theAlbumArt = defAlbumArt;
			$('#albumArt').fadeTo(0, 1);
			$('#albumArt').attr('src', theAlbumArt);
			$('#albumArt').attr('width', myWidth);
			$('#albumArt').attr('height', myWidth);
			$('#songTitle').text(stringLiveStream);
			$('#songArtist').text('');
			$('#songAlbum').text('');
			formatPages();

			playThisStream();
		} else {
			displayBlackoutPopup();
		}
	} else {
		flagClear = true;
		odPlayer = true;
		stopStream(true);
		theStreamUrl = substr[0];
		audioStream.src = theStreamUrl;
		myOdCampaignId = substr[3];
		theTitle = substr[1];
		theArtist = "";
		theAlbum = "";
		songDuration = substr[2];
		playThisStream();
	}
}
// END

// HANDLES SHARE SERVICE SELECTION
function loadShareList() {
	$('#shareList').empty();
	for (var i = 0; i < shareList.length; i++) {
		var shareImage = shareList[i] + ".png";
		$('#shareList').append('<li data-val="' + shareList[i] + '"><div class="shareList"><div class="img-cont"><img src="images/' + shareImage + '" /></div><span>' + shareList[i] + '</span></div></li>');
	}
	$('#shareList').mobiscroll().image( {
		theme: 'ios',
		display: scrollerPosition,
		mode: 'scroller',
		inputClass: 'i-txt',
		setText: 'Share',
		onSelect: setShare
	});
	$('#shareList').height(100);
	$('#shareList').scroller('show');
}

function setShare(shareData) {
	shareSong(shareData);
}
// END

// OPENS A NEW WINDOW WITH URL
function openSocial(theUrl) {
	$('body').addClass("loading");
	window.open(theUrl, '_system');
}
// END

// GETS BLACKOUT STATUS
function fetchBlackoutStatus() {
	$.ajax( {
		type: 'GET',
		url: urlCheckBlackout + theCallSign,
		dataType: 'xml',
		success: function(data) {
			blackoutActive = $(data).find('blackoutActive').first().text();
		}
	});
}
// END

// DISPLAY BLACKOUT POPUP
function displayBlackoutPopup() {
	if (!alreadyDisplayedBlackoutMessage) {
		alreadyDisplayedBlackoutMessage = true;
		navigator.notification.alert(stringBlackoutNotification);
	}
}
// END

// GETS SONG INFO
function fetchSongInfo() {
	if (!odPlayer) {
		$.ajax( {
			type: 'GET',
			url: statusUrl,
			dataType: 'xml',
			success: getSongInfo
		});
	} else {
		// SEE IF WE HAVE AN ON-DEMAND IMPRESSION MARK THAT NEEDS TO BE SENT
		for (var i = 0; i < impressionMarkList.length; i++) {
			if (impressionMarkList[i][0] === "PGM") {
				theOdImpressionMarkTime = impressionMarkList[i][1];
			}
		}
		// END
		if (theTitle !== curTitle) {
			theAlbumArt = myOdImage;
			$('#albumArt').fadeTo(0, 1);
			$('#albumArt').attr('src', theAlbumArt);
			$('#albumArt').attr('width', myWidth);
			$('#albumArt').attr('height', myWidth);

			$('#songInfoDiv').hide();
			clearInterval(songProgressRefresh);
			var d = new Date();
			pE.position = 0;
			pE.duration = songDuration;

			$('#mSongDuration').html(parseTimeInterval(pE.duration));

			$('#songTitle').text(theTitle);
			$('#songArtist').text(theArtist);
			$('#songAlbum').text($(this).find('album').text());
			realignSongInfo();
			curTitle = theTitle;
			songProgressRefresh = setInterval('dspProgress()', 1000);
		}
	}
}

function getSongInfo(xml) {
	$(xml).find('playlist').each(function() {
		if ($(this).find('programType').text() === 'PGM') {
			if ((!isPlaying) && (!intentionalStop)) {
				if (playerAdvertisingMode !== 'ADN') {
					if (prerollCompleted) {
						if (rejoinPriority === 'PGM') {
							if (audioAdReplacement) {
								if (!audioAdReplacement.paused) {
									audioAdReplacement.pause();
								}
							}
							audioAdReplacement = null;
							isPlayingAra = false;
							if ((!sleepTimer) && (!alarmScheduled)) {
								timeoutID = window.setTimeout(playThisStream, 0);
							}
						} else if (rejoinPriority === 'SPT') {
							if (!isPlayingAra) {
								if (audioAdReplacement) {
									if (!audioAdReplacement.paused) {
										audioAdReplacement.pause();
									}
								}
								audioAdReplacement = null;
								if (streamStartMode === 'live') {
									if ((!sleepTimer) && (!alarmScheduled)) {
										timeoutID = window.setTimeout(playThisStream, 0);
									}
								}
							}
						}
					}
				} else {
					if (prerollCompleted) {
						if ((!sleepTimer) && (!alarmScheduled)) {
							timeoutID = window.setTimeout(playThisStream, 0);
						}
					}
				}
			}

			if ($(this).find('cover').text().length === 0) {
				theAlbumArt = defAlbumArt;
			} else {
				theAlbumArt = $(this).find('cover').text();
			}
			$('#albumArt').fadeTo(0, 1);
			$('#albumArt').attr('src', theAlbumArt);
			$('#albumArt').attr('width', myWidth);
			$('#albumArt').attr('height', myWidth);

			theArtist = $(this).find('artist').text();
			theTitle = $(this).find('title').text();
			theAlbum = $(this).find('album').text();
			songDuration = $(this).find('duration').text();
			programStartTS = $(this).find('programStartTS').text();

			if (theTitle !== curTitle) {
				// ADDS CURRENT SONG TO THE PLAYLIST
				var myImage = '<div class="playlistArt" style="width:' + myPlWidth + 'px; height:' + myPlWidth + 'px; background-image:url(' + theAlbumArt + '); background-size:cover;"><div class="playlistData">' + theTitle + '<hr color="#ffffff" width="80%">' + theArtist + '</div></div>';
				$('#makeMeScrollable').smoothDivScroll('getHtmlContent', myImage, 'addFirst');
				resizePlaylist();
				// END
				$('#songInfoDiv').hide();
				clearInterval(songProgressRefresh);
				var d = new Date();
				pE.position = parseInt(((d.getTime() + d.getTimezoneOffset() * 60000) - localServerTSoffset - Date.parse(programStartTS)) / 1000, 10);
				pE.duration = songDuration;

				if (statusUrl.length > 0) {
					$('#mSongDuration').html(parseTimeInterval(pE.duration));
				}
				$('#songTitle').text(theTitle);
				$('#songArtist').text(theArtist);
				$('#songAlbum').text($(this).find('album').text());

				curTitle = theTitle;
				songProgressRefresh = setInterval('dspProgress()', 1000);
				fetchLyrics(theArtist, theTitle);
			}
		} else {
			if ((sLocaFillOnAdnFail === "true") || (playerAdvertisingMode === "STN")) {
				if ((!isPlayingAra) && (!intentionalStop)) {
					getAdReplacementAudio();
				}
			}

			$('#songTitle').text(stringAdMode);
			$('#songArtist').text(stringAdMode2);
			$('#songAlbum').text('');

			clearInterval(songProgressRefresh);
			$('#mSongProgressSlider').val(0);
			$('#mSongTime').text(stringSongTimerPlaceholder);
			if (statusUrl.length > 0) {
				$('#mSongDuration').html(parseTimeInterval(pE.duration));
			}
		}
		realignSongInfo();
	});
}
// END

// POSITION THE SONG INFO BELOW ALBUM ART
function realignSongInfo() {
	var theTop = ($('#albumArt').offset().top + (myWidth - (myWidth * 0.10) - ($('#songInfoDiv').height())));
	var theLeft = $('#albumArt').position().left;

	$('#songInfoDiv').width(myWidth);
	$('#songInfoDiv').css('top', theTop + 'px');
	$('#songInfoDiv').css('left', theLeft + 'px');
	$('#songInfoDiv').show();
}
// END

// GETS SONG LYRICS
function fetchLyrics(artist, title) {
	$.ajax( {
		type: 'GET',
		url: urlLyricsProvider + theCallSign + '&playSessionID=' + playSessionID + '&artist=' + artist + '&title=' + title,
		dataType: 'xml',
		success: getLyrics
	});
}

function getLyrics(xml) {
	if ($(xml).children('lyrics').text().length > 0) {
		var lyrics = $(xml).children('lyrics').text();
		$('#lyricsTitle').html(theTitle);
		$('#lyricsContent').html(nl2br(lyrics, false));

		var lyricsHeight = $(window).height() - $('#playerTransport').height();
		$('#lyricsContainer').css('height', lyricsHeight + 'px');
	} else {
		$('#lyricsTitle').html(theTitle);
		$('#lyricsContent').text(stringNoLyrics);
	}
}

function nl2br(str, is_xhtml) {
	var breakTag = (is_xhtml || typeof is_xhtml === 'undefined') ? '<br />' : '<br>';
	return (str + '').replace(/([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1' + breakTag + '$2');
}
// END

// GETS PLAYLIST
function fetchPlaylist() {
	$.ajax( {
		type: 'GET',
		url: urlPlaylistProvider + theAuthToken + '&stationCallSign=' + theCallSign,
		dataType: 'xml',
		success: getPlaylist
	});
}

function getPlaylist(xml) {
	$(xml).find('song:gt(0)').each(function() {
		coverArt = $(this).find('cover').text();
		title = $(this).find('title').text();
		artist = $(this).find('artist').text();

		if (coverArt.length === 0) {
			coverArt = defAlbumArt;
		}

		if (title !== curTitle) {
			$('#makeMeScrollable').append('<div class="playlistArt" style="width:' + myPlWidth + 'px; height:' + myPlWidth + 'px; background-image:url(' + coverArt + '); background-size:cover;"><div class="playlistData">' + title + '<hr color="#ffffff" width="80%">' + artist + '</div></div>');
		}
	});
	resizePlaylist();
	initPlaylist();
}

function initPlaylist() {
	$('#makeMeScrollable').smoothDivScroll( {
		mousewheelScrolling: "",
		manualContinuousScrolling: false,
		autoScrollingMode: "",
		touchScrolling: true,
		hotSpotScrolling: false
	});
	$('#makeMeScrollable').smoothDivScroll('recalculateScrollableArea');
}

function resizePlaylist() {
	$('#makeMeScrollable').css('height', myPlWidth + 'px');
	$('.playlistArt').css('width', myPlWidth + 'px');
	$('.playlistArt').css('height', myPlWidth + 'px');
	$('.playlistArt').css('background-size', 'cover');
}
// END

// SETS BACKGROUND ON ALL CONTENT AREAS AND LOGOS
function formatPages() {
	var theHeight = $(window).height();
	if (playerAdvertisingMode == 'STN' || playerAdvertisingMode == 'ADN') {
		theHeight -= 50;
	}

	$('#main').css( {
		'height': '99%',
		'max-height': '99%',
		'background-image': 'url(' + bgUrl + ')',
		'background-size': '100% 100%',
		'background-repeat': 'repeat-y',
		'background-attachment': 'fixed',
		'-webkit-touch-callout': 'none'
	});

	$('#menuLogo, #stationLogo, #stationInfoLogo, #lyricsLogo, #playlistLogo, #buySongLogo, #mosquitoZapperLogo, #cAlarmLogo, #cSleepLogo').attr('src', logoUrl);
	$('#menuLogo, #stationLogo, #stationInfoLogo, #lyricsLogo, #playlistLogo, #buySongLogo, #mosquitoZapperLogo, #cAlarmLogo, #cSleepLogo').attr('width', '75%');
	$('#menuLogo, #stationLogo, #stationInfoLogo, #lyricsLogo, #playlistLogo, #buySongLogo, #mosquitoZapperLogo, #cAlarmLogo, #cSleepLogo').attr('height', 'auto');

	$('#stationSlogan').text(stationSlogan);
	$('#stationInfo').text(stationInfo);

	$('#albumArt').fadeTo(0, 1);
	$('#albumArt').attr('src', defAlbumArt);

	$('#albumArt').attr('position', 'absolute');
	$('#albumArt').attr('top', '0px');
	$('#albumArt').attr('left', '0px');
	$('#albumArt').attr('width', myWidth);
	$('#albumArt').attr('height', myWidth);

	if (stationPhone.length > 0) {
		$('#thePhone').attr('href', 'tel:' + stationPhone);
	} else {
		$('#thePhone').hide();
	}

	if (stationEmail.length > 0) {
		$('#theEmail').attr('href', 'mailto:' + stationEmail);
	} else {
		$('#theEmail').hide();
	}

	if (stationUrl.length <= 0) {
		$('#theUrl').attr('onclick', '');
		$('#theUrl').hide();
	}
}
// END

// PLAYS THE STREAM
function playThisStream() {
	if ((blackoutActive != "true") || (odPlayer)) {
		alreadyDisplayedBlackoutMessage = false;
		isPlaying = true;
		flagClear = false;

		audioStream.addEventListener("error", function() {
			alert("Error playing audio stream");
		}, false);
		audioStream.addEventListener("canplay", function() {
		}, false);
		audioStream.addEventListener("waiting", function() {
			isPlaying = false;
		}, false);
		audioStream.addEventListener("playing", function() {
			isPlaying = true;
			$('#mPlayerPlayDiv').hide();
			$('#mPlayerLoadingDiv').hide();
			$('#mPlayerStopDiv').show();
		}, false);
		audioStream.addEventListener("ended", function() {
			audioFullStop();
		}, false);
		audioStream.addEventListener("pause", function() {
			$('#mPlayerStopDiv').hide();
			$('#mPlayerLoadingDiv').hide();
			$('#mPlayerPlayDiv').show();
		}, false);

		audioStream.play();
	} else {
		stopStream(true);
		displayBlackoutPopup();
	}

	if (odPlayer) {
		$('#mSongProgressSlider').attr('max', songDuration);
		$('#mSongProgressSlider').change(function() {
			var slider_value = $(this).val();
			clearInterval(songProgressRefresh);
			audioStream.currentTime = slider_value;
			pE.position = slider_value;
			songProgressRefresh = setInterval('dspProgress()', 1000);
		});
	} else {
		pE.position = 0;
		clearInterval(songProgressRefresh);
		songProgressRefresh = setInterval('dspProgress()', 1000);
	}

	navigator.notification.activityStart();
}
// END

// FULL STOP OF AUDIO
function audioFullStop() {
	isPlaying = false;
	clearInterval(readyStateInterval);
	audioStream.pause();
	$('#mPlayerStopDiv').hide();
	$('#mPlayerLoadingDiv').hide();
	$('#mPlayerPlayDiv').show();
	audioStream = null;
	audioStream = new Audio(theStreamUrl);
}
// END

// STOPS THE STREAM
function stopStream(intentional) {
	if (intentional) {
		intentionalStop = true;
	} else {
		intentionalStop = false;
	}
	isPlaying = false;
	clearInterval(readyStateInterval);
	clearInterval(songProgressRefresh);
	audioStream.pause();
	$('#mPlayerStopDiv').hide();
	$('#mPlayerLoadingDiv').hide();
	$('#mPlayerPlayDiv').show();

	if (odPlayer) {
		clearInterval(songProgressRefresh);
		if (flagClear) {
			pE.position = 0;
		}
	}
}
// END

// FOR SONG INFO DISPLAY
function dspProgress() {
	/* SHOW SONG TIMER IF STATION HAS DCS *OR* PLAYING ON-DEMAND */
	if ((statusUrl.length > 0) || (odPlayer)) {
		pE.position++;
		$('#mSongTime').html(parseTimeInterval(pE.position));
		var divWidth = $('#mSongProgressDiv').width();
		var progressScale = divWidth / pE.duration;

		if (pE.position <= pE.duration) {
			$('#mSongProgressSlider').attr('max', pE.duration);
			$('#mSongProgressSlider').val(pE.position);

			// FIRE ON-DEMAND IMPRESSION MARK IF WE HAVE ONE
			if (theOdImpressionMarkTime > 0) {
				if (pE.position === theOdImpressionMarkTime) {
					$.get(impressionMarkUrl, {
						stationCallSign: theCallSign,
						sfyProgramType: "PGM",
						sfyMediaType: "OD",
						adCampaignId: myOdCampaignId,
						updateScope: "listened"
					});
				}
			}
			// END
		}
	}
}

function parseTimeInterval(secs) {
	var t = new Date(1970, 0, 1);
	t.setSeconds(secs);
	tA = t.toTimeString().substr(0, 8).split(':');
	if (tA == "Invalid") {
		tA = 0;
	}
	return (tA[0] !== '00' ? tA[0] + ':' : '') + tA[1] + ':' + tA[2];
}
// END

// BUY MEDIA
function buyMedia() {
	$('body').addClass("loading");
	window.location.href = urlBuyMedia + theCallSign + '&artist=' + theArtist + '&album=' + theAlbum + '&title=' + theTitle;
}
// END

// GETS AD REPLACEMENT AUDIO
function getAdReplacementAudio() {
	var requestUrl = adCampaignGetURL +
		"?stationCallSign=" + theCallSign +
		"&ctype=ARA" +
		"&adTypePos=1" +
		"&externalProvider=" +
		"&geoCTCode=" + geoCTCode +
		"&geoDMACode=" + geoDMACode +
		"&sGenre=" + sGenre +
		"&deviceType=" + thisDevice +
		"&deviceOrientation=" + deviceOrientation;

	$.getJSON(requestUrl, function (res) {
		var fA = res['filledAssetTypes'].split(",");
		var fNum = res['filledAssetCount'];
		if (fNum > 0) {
			if (res['adCampaignAssets'][fA[0]]['mediaType'] === "AUD") {
				stopStream(true);
				isPlayingAra = true;

				$('#mPlayerStopDiv').hide();
				$('#mPlayerPlayDiv').hide();
				$('#mPlayerLoadingDiv').show();

				var araAudioUrl = res['adCampaignAssets'][fA[0]]['mediaSRC'];
				audioAdReplacement = new Audio();
				audioAdReplacement.src = araAudioUrl;
				audioAdReplacement.addEventListener('ended', function() {
					isPlayingAra = false;
					audioAdReplacement.src = "foo";
				}, false);
				audioAdReplacement.play();
			}
		} else {
			isPlayingAra = false;
		}
	});
}
// END

// BANNER AD CONTROLLER
function getBanner() {
	if (showAds === "true") {
		if (playerAdvertisingMode === "ADN") {
            prerollCompleted = true;
            prerollPlaying = false;
			responseString = playerAdvertisingMode + "," + bannerRotationFqcy + ",NULL,NULL";
		} else if (playerAdvertisingMode === "SEQ") {
            prerollCompleted = true;
            prerollPlaying = false;
			responseString = playerAdvertisingMode + "," + bannerRotationFqcy + ",NULL,NULL";
		} else {
			if (!prerollCompleted) {
				if (!prerollPlaying) {
					if (!prbCompleted) {
						// GET PREROLL BANNER
						responseString = "***** PRBCOMPLETED IS FALSE *****";
						prerollPlaying = true;
						var requestUrl = adCampaignGetURL +
							"?stationCallSign=" + theCallSign +
							"&ctype=PRB" +
							"&adTypePos=1" +
							"&externalProvider=" +
							"&geoCTCode=" + geoCTCode +
							"&geoDMACode=" + geoDMACode +
							"&sGenre=" + sGenre +
							"&deviceType=" + thisDevice +
							"&deviceOrientation=" + deviceOrientation;

						$.getJSON(requestUrl, function (res) {
							var fA = res['filledAssetTypes'].split(",");
							var fNum = res['filledAssetCount'];

							if (fNum > 0) {
								for (i = 0; i < fA.length; i++) {
									if (res['adCampaignAssets'][fA[i]]['mediaType'] === "BNR") {
										var bannerImg = res['adCampaignAssets'][fA[i]]['mediaSRC'];
										var bannerLink = res['adCampaignAssets'][fA[i]]['link'];

										if (bannerImg !== "") {
											$('#prerollBanner').css('background-image', 'url(' + bannerImg + ')');
											$('#prerollBanner').css('background-position','center center');
											$('#prerollBanner').css('background-repeat','no-repeat');
											$('#prerollBanner').css('background-size','contain');

											if (bannerLink.length) {
												$('#prerollBanner').click(function() {
													disablePopup();
													openSocial(bannerLink);
												});
											}

											centerPopup();
											loadPopup();

											var counter = 0;
											var interval = setInterval(function() {
												counter += 1;
												if (counter >= prerollBannerDuration) {
													disablePopup();
													clearInterval(interval);
												}
											}, 1000);
										} else {
											prerollPlaying = false;
											prbCompleted = true;
										}
									} else {
										prerollPlaying = false;
										prbCompleted = true;
									}
								}
							} else {
								prerollPlaying = false;
								prbCompleted = true;
							}
						});
						// END
					} else {
						// GET PREROLL AUDIO + BANNER
						prerollPlaying = true;
						var requestUrl = adCampaignGetURL +
							"?stationCallSign=" + theCallSign +
							"&ctype=PRA" +
							"&adTypePos=1" +
							"&externalProvider=" +
							"&geoCTCode=" + geoCTCode +
							"&geoDMACode=" + geoDMACode +
							"&sGenre=" + sGenre +
							"&deviceType=" + thisDevice +
							"&deviceOrientation=" + deviceOrientation;

						$.getJSON(requestUrl, function (res) {
							var fA = res['filledAssetTypes'].split(",");
							var fNum = res['filledAssetCount'];

							if (fNum > 0) {
								for (ii = 0; ii < fA.length; ii++) {
									if (res['adCampaignAssets'][fA[ii]]['mediaType'] === "BNR") {
										var hasBanner = true;
										var bannerImg = res['adCampaignAssets'][fA[ii]]['mediaSRC'];
										var bannerLink = res['adCampaignAssets'][fA[ii]]['link'];

										if (bannerImg !== "") {
											responseString = playerAdvertisingMode + "," + bannerRotationFqcy + "," + bannerImg + "," + bannerLink;
										}
									} else if (res['adCampaignAssets'][fA[ii]]['mediaType'] === "AUD") {
										praAudioUrl = res['adCampaignAssets'][fA[ii]]['mediaSRC'];
										var audioPreroll = new Audio();
										var praAudioDuration;
										audioPreroll.src = praAudioUrl;
										audioPreroll.addEventListener('loadedmetadata', function() {
											praAudioDuration = Math.round(audioPreroll.duration);

											pE.position = 0;
											pE.duration = praAudioDuration;
											if (statusUrl.length > 0) {
												$('#mSongDuration').html(parseTimeInterval(pE.duration));
											}
											clearInterval(songProgressRefresh);
											songProgressRefresh = setInterval('dspProgress()', 1000);
										}, false);
										audioPreroll.addEventListener('ended', function() {
											prerollCompleted = true;
											prerollPlaying = false;
											audioPreroll.src = "foo";

											if (streamStartMode === 'live') {
												// RESET SONG TIMER
												pE.position = 0;
												pE.duration = songDuration;
												if (statusUrl.length > 0) {
													$('#mSongDuration').html(parseTimeInterval(pE.duration));
												}
												clearInterval(songProgressRefresh);
												songProgressRefresh = setInterval('dspProgress()', 1000);
												// END

												if ((!sleepTimer) && (!alarmScheduled)) {
													timeoutID = window.setTimeout(playThisStream, 0);
												}
											} else {
												loadFileList();
												if (odAutoStart === 'true') {
													var thisFileUrl = myStreamRoot + "/" + myOdPath + "/" + fileList[0][1];
													var thisDataString = thisFileUrl + ',' + fileList[0][2] + ',' + fileList[0][3] + fileList[0][4];
													setFile(thisDataString);
												}
											}
										}, false);
										audioPreroll.addEventListener('timeupdate', function() {
											// INTENTIONALLY BLANK
										}, false);

										try {
											audioPreroll.play();
										} catch (err) {
											prerollCompleted = true;
											prerollPlaying = false;

											// RESET SONG TIMER
											pE.position = 0;
											pE.duration = songDuration;
											if (statusUrl.length > 0) {
												$('#mSongDuration').html(parseTimeInterval(pE.duration));
											}
											clearInterval(songProgressRefresh);
											songProgressRefresh = setInterval('dspProgress()', 1000);
											// END

											if ((!sleepTimer) && (!alarmScheduled)) {
												timeoutID = window.setTimeout(playThisStream, 0);
											}
										}
									}
								}
							} else {
								prerollCompleted = true;
								prerollPlaying = false;

								// RESET SONG TIMER
								pE.position = 0;
								pE.duration = songDuration;
								if (statusUrl.length > 0) {
									$('#mSongDuration').html(parseTimeInterval(pE.duration));
								}
								clearInterval(songProgressRefresh);
								songProgressRefresh = setInterval('dspProgress()', 1000);
								// END

								if ((!sleepTimer) && (!alarmScheduled)) {
									timeoutID = window.setTimeout(playThisStream, 0);
								}
							}
						});
						// END
					}
				}
			} else {
				// GET A BANNER AD
				curTimeStamp = new Date();
				curTimeStamp = curTimeStamp.getTime();

				if (curTimeStamp >= (oldTimeStamp + (bannerRotationFqcy * 1000))) {
					var requestUrl = adCampaignGetURL +
						"?stationCallSign=" + theCallSign +
						"&ctype=BNR" +
						"&adTypePos=1" +
						"&externalProvider=" +
						"&geoCTCode=" + geoCTCode +
						"&geoDMACode=" + geoDMACode +
						"&sGenre=" + sGenre +
						"&deviceType=" + thisDevice +
						"&deviceOrientation=" + deviceOrientation;

					$.getJSON(requestUrl, function (res) {
						var fA = res['filledAssetTypes'].split(",");
						var fNum = res['filledAssetCount'];
						if (fNum > 0) {
							if (res['adCampaignAssets'][fA[0]]['mediaType'] === "BNR") {
								oldTimeStamp = curTimeStamp;  // ONLY UPDATE TIMESTAMP IF WE ACTUALLY SHOW A BANNER
								bannerImageUrl = res['adCampaignAssets'][fA[0]]['mediaSRC'];
								bannerLinkUrl = res['adCampaignAssets'][fA[0]]['link'];
								responseString = playerAdvertisingMode + "," + bannerRotationFqcy + "," + bannerImageUrl + "," + bannerLinkUrl;
							}
						} else {
							responseString = playerAdvertisingMode + "," + bannerRotationFqcy + ",NULL,NULL";
						}
					});
				}
				// END
			}
		}
	} else {
        prerollCompleted = true;
        prerollPlaying = false;
        
        // RESET SONG TIMER
        pE.position = 0;
        pE.duration = songDuration;
        if (statusUrl.length > 0) {
            $('#mSongDuration').html(parseTimeInterval(pE.duration));
        }
        clearInterval(songProgressRefresh);
        songProgressRefresh = setInterval('dspProgress()', 1000);
        // END
        if ((!sleepTimer) && (!alarmScheduled) && (!intentionalStop)) {
            timeoutID = window.setTimeout(playThisStream, 0);
        }
        
		responseString = "***** NO ADS *****";
	}

if ((!sleepTimer) && (!alarmScheduled) && (audioStream.paused) && (!intentionalStop) && (prerollCompleted)) {
	// RESET SONG TIMER
	pE.position = 0;
	pE.duration = songDuration;
	if (statusUrl.length > 0) {
		$('#mSongDuration').html(parseTimeInterval(pE.duration));
	}
	clearInterval(songProgressRefresh);
	songProgressRefresh = setInterval('dspProgress()', 1000);
	// END

	timeoutID = window.setTimeout(playThisStream, 0);
}

return responseString;
}
// END